libstdc++: std::__debug::bitset< _Nb > Class Template Reference

libstdc++

std::__debug::bitset< _Nb > Class Template Reference

`#include <bitset>`

## Public Types
typedef _Base::reference | reference

## Public Member Functions
constexpr | bitset (const _Base &__x)
template<typename _CharT, typename = _Require<is_trivially_copyable<_CharT>, is_standard_layout<_CharT>, is_trivially_default_constructible<_CharT>, __not_<is_array<_CharT>>>>
constexpr | bitset (const _CharT *__str, typename std::basic_string< _CharT >::size_type __n=std::basic_string< _CharT >::npos, _CharT __zero=_CharT('0'), _CharT __one=_CharT('1'))
template<class _CharT, class _Traits, class _Alloc>
constexpr | bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__str, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __pos, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __n, _CharT __zero, _CharT __one=_CharT('1'))
template<typename _CharT, typename _Traits, typename _Alloc>
constexpr | bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__str, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __pos=0, typename std::basic_string< _CharT, _Traits, _Alloc >::size_type __n=(std::basic_string< _CharT, _Traits, _Alloc >::npos))
constexpr | bitset (unsigned long long __val) noexcept
constexpr const _Base & | _M_base () const noexcept
constexpr _Base & | _M_base () noexcept
constexpr bitset< _Nb > & | flip () noexcept
constexpr bitset< _Nb > & | flip (size_t __pos)
constexpr bitset< _Nb > & | operator&= (const bitset< _Nb > &__rhs) noexcept
constexpr bitset< _Nb > | operator<< (size_t __pos) const noexcept
constexpr bitset< _Nb > & | operator<<= (size_t __pos) noexcept
constexpr bool | operator== (const bitset< _Nb > &__rhs) const noexcept
constexpr bitset< _Nb > | operator>> (size_t __pos) const noexcept
constexpr bitset< _Nb > & | operator>>= (size_t __pos) noexcept
constexpr reference | operator[] (size_t __pos)
constexpr bool | operator[] (size_t __pos) const
constexpr bitset< _Nb > & | operator^= (const bitset< _Nb > &__rhs) noexcept
constexpr bitset< _Nb > & | operator|= (const bitset< _Nb > &__rhs) noexcept
constexpr bitset< _Nb > | operator~ () const noexcept
constexpr bitset< _Nb > & | reset () noexcept
constexpr bitset< _Nb > & | reset (size_t __pos)
constexpr bitset< _Nb > & | set () noexcept
constexpr bitset< _Nb > & | set (size_t __pos, bool __val=true)
template<typename _CharT, typename _Traits, typename _Alloc>
constexpr std::basic_string< _CharT, _Traits, _Alloc > | to_string () const
template<typename _CharT, typename _Traits>
constexpr std::basic_string< _CharT, _Traits, std::allocator< _CharT > > | to_string () const
template<typename _CharT>
constexpr std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > | to_string () const
constexpr std::basic_string< char, std::char_traits< char >, std::allocator< char > > | to_string () const
template<class _CharT, class _Traits, class _Alloc>
constexpr std::basic_string< _CharT, _Traits, _Alloc > | to_string (_CharT __zero, _CharT __one=_CharT('1')) const
template<class _CharT, class _Traits>
constexpr std::basic_string< _CharT, _Traits, std::allocator< _CharT > > | to_string (_CharT __zero, _CharT __one=_CharT('1')) const
template<class _CharT>
constexpr std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > | to_string (_CharT __zero, _CharT __one=_CharT('1')) const
constexpr std::basic_string< char, std::char_traits< char >, std::allocator< char > > | to_string (char __zero, char __one='1') const

## Detailed Description

template<size_t _Nb>
class std::__debug::bitset< _Nb >

Class std::bitset with additional safety/checking/debug instrumentation.

Definition at line 46 of file debug/bitset.

## Member Typedef Documentation

## ◆ reference

template<size_t _Nb>

typedef _Base::reference std::__debug::bitset< _Nb >::reference

Definition at line 59 of file debug/bitset.

## Constructor & Destructor Documentation

## ◆ bitset() [1/6]

template<size_t _Nb>

std::__debug::bitset< _Nb >::bitset | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 135 of file debug/bitset.

## ◆ bitset() [2/6]

template<size_t _Nb>

std::__debug::bitset< _Nb >::bitset | ( | unsigned long long | __val | ) |
| inlineconstexprnoexcept

Definition at line 139 of file debug/bitset.

## ◆ bitset() [3/6]

template<size_t _Nb>
template<typename _CharT, typename _Traits, typename _Alloc>

std::__debug::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | typename std::basic_string< _CharT, _Traits, _Alloc >::size_type | __pos = 0,
|  | typename std::basic_string< _CharT, _Traits, _Alloc >::size_type | __n = (std::basic_string<_CharT, _Traits, _Alloc>::npos) )
| inlineexplicitconstexpr

Definition at line 148 of file debug/bitset.

## ◆ bitset() [4/6]

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>

std::__debug::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __str,
|  | typename std::basic_string< _CharT, _Traits, _Alloc >::size_type | __pos,
|  | typename std::basic_string< _CharT, _Traits, _Alloc >::size_type | __n,
|  | _CharT | __zero,
|  | _CharT | __one = _CharT('1') )
| inlineconstexpr

Definition at line 159 of file debug/bitset.

## ◆ bitset() [5/6]

template<size_t _Nb>

std::__debug::bitset< _Nb >::bitset | ( | const _Base & | __x | ) |
| inlineconstexpr

Definition at line 179 of file debug/bitset.

## ◆ bitset() [6/6]

template<size_t _Nb>
template<typename _CharT, typename = _Require<is_trivially_copyable<_CharT>, is_standard_layout<_CharT>, is_trivially_default_constructible<_CharT>, __not_<is_array<_CharT>>>>

std::__debug::bitset< _Nb >::bitset | ( | const _CharT * | __str,
|  | typename std::basic_string< _CharT >::size_type | __n = std::basic_string<_CharT>::npos,
|  | _CharT | __zero = _CharT('0'),
|  | _CharT | __one = _CharT('1') )
| inlineexplicitconstexpr

Definition at line 191 of file debug/bitset.

## Member Function Documentation

## ◆ _M_base() [1/2]

template<size_t _Nb>

const _Base & std::__debug::bitset< _Nb >::_M_base | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 431 of file debug/bitset.

## ◆ _M_base() [2/2]

template<size_t _Nb>

_Base & std::__debug::bitset< _Nb >::_M_base | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 426 of file debug/bitset.

## ◆ flip() [1/2]

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::flip | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 280 of file debug/bitset.

## ◆ flip() [2/2]

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::flip | ( | size_t | __pos | ) |
| inlineconstexpr

Definition at line 288 of file debug/bitset.

## ◆ operator&=()

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::operator&= | ( | const bitset< _Nb > & | __rhs | ) |
| inlineconstexprnoexcept

Definition at line 201 of file debug/bitset.

## ◆ operator<<()

template<size_t _Nb>

bitset< _Nb > std::__debug::bitset< _Nb >::operator<< | ( | size_t | __pos | ) | const
| inlineconstexprnoexcept

Definition at line 414 of file debug/bitset.

## ◆ operator<<=()

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::operator<<= | ( | size_t | __pos | ) |
| inlineconstexprnoexcept

Definition at line 223 of file debug/bitset.

## ◆ operator==()

template<size_t _Nb>

bool std::__debug::bitset< _Nb >::operator== | ( | const bitset< _Nb > & | __rhs | ) | const
| inlineconstexprnoexcept

Definition at line 400 of file debug/bitset.

## ◆ operator>>()

template<size_t _Nb>

bitset< _Nb > std::__debug::bitset< _Nb >::operator>> | ( | size_t | __pos | ) | const
| inlineconstexprnoexcept

Definition at line 421 of file debug/bitset.

## ◆ operator>>=()

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::operator>>= | ( | size_t | __pos | ) |
| inlineconstexprnoexcept

Definition at line 233 of file debug/bitset.

## ◆ operator[]() [1/2]

template<size_t _Nb>

reference std::__debug::bitset< _Nb >::operator[] | ( | size_t | __pos | ) |
| inlineconstexpr

Definition at line 299 of file debug/bitset.

## ◆ operator[]() [2/2]

template<size_t _Nb>

bool std::__debug::bitset< _Nb >::operator[] | ( | size_t | __pos | ) | const
| inlineconstexpr

Definition at line 312 of file debug/bitset.

## ◆ operator^=()

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::operator^= | ( | const bitset< _Nb > & | __rhs | ) |
| inlineconstexprnoexcept

Definition at line 217 of file debug/bitset.

## ◆ operator|=()

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::operator|= | ( | const bitset< _Nb > & | __rhs | ) |
| inlineconstexprnoexcept

Definition at line 209 of file debug/bitset.

## ◆ operator~()

template<size_t _Nb>

bitset< _Nb > std::__debug::bitset< _Nb >::operator~ | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 275 of file debug/bitset.

## ◆ reset() [1/2]

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::reset | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 259 of file debug/bitset.

## ◆ reset() [2/2]

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::reset | ( | size_t | __pos | ) |
| inlineconstexpr

Definition at line 267 of file debug/bitset.

## ◆ set() [1/2]

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::set | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 241 of file debug/bitset.

## ◆ set() [2/2]

template<size_t _Nb>

bitset< _Nb > & std::__debug::bitset< _Nb >::set | ( | size_t | __pos,
|  | bool | __val = true )
| inlineconstexpr

Definition at line 251 of file debug/bitset.

## ◆ to_string() [1/8]

template<size_t _Nb>
template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_string< _CharT, _Traits, _Alloc > std::__debug::bitset< _Nb >::to_string | ( |  | ) | const
| inlineconstexpr

Definition at line 329 of file debug/bitset.

## ◆ to_string() [2/8]

template<size_t _Nb>
template<typename _CharT, typename _Traits>

std::basic_string< _CharT, _Traits, std::allocator< _CharT > > std::__debug::bitset< _Nb >::to_string | ( |  | ) | const
| inlineconstexpr

Definition at line 348 of file debug/bitset.

## ◆ to_string() [3/8]

template<size_t _Nb>
template<typename _CharT>

std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > std::__debug::bitset< _Nb >::to_string | ( |  | ) | const
| inlineconstexpr

Definition at line 364 of file debug/bitset.

## ◆ to_string() [4/8]

template<size_t _Nb>

std::basic_string< char, std::char_traits< char >, std::allocator< char > > std::__debug::bitset< _Nb >::to_string | ( |  | ) | const
| inlineconstexpr

Definition at line 382 of file debug/bitset.

## ◆ to_string() [5/8]

template<size_t _Nb>
template<class _CharT, class _Traits, class _Alloc>

std::basic_string< _CharT, _Traits, _Alloc > std::__debug::bitset< _Nb >::to_string | ( | _CharT | __zero,
|  | _CharT | __one = _CharT('1') ) const
| inlineconstexpr

Definition at line 337 of file debug/bitset.

## ◆ to_string() [6/8]

template<size_t _Nb>
template<class _CharT, class _Traits>

std::basic_string< _CharT, _Traits, std::allocator< _CharT > > std::__debug::bitset< _Nb >::to_string | ( | _CharT | __zero,
|  | _CharT | __one = _CharT('1') ) const
| inlineconstexpr

Definition at line 356 of file debug/bitset.

## ◆ to_string() [7/8]

template<size_t _Nb>
template<class _CharT>

std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > std::__debug::bitset< _Nb >::to_string | ( | _CharT | __zero,
|  | _CharT | __one = _CharT('1') ) const
| inlineconstexpr

Definition at line 374 of file debug/bitset.

## ◆ to_string() [8/8]

template<size_t _Nb>

std::basic_string< char, std::char_traits< char >, std::allocator< char > > std::__debug::bitset< _Nb >::to_string | ( | char | __zero,
|  | char | __one = '1' ) const
| inlineconstexpr

Definition at line 389 of file debug/bitset.

The documentation for this class was generated from the following file:

- debug/bitset